gtkmm: Gtk::GestureRotate Class Reference

gtkmm 4.8.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::GestureRotate Class Reference
Event Controllers and Gestures

Rotate gesture. More...

`#include <gtkmm/gesturerotate.h>`

Inheritance diagram for Gtk::GestureRotate:
[legend]

## Public Member Functions
| GestureRotate (GestureRotate && src) noexcept
GestureRotate & | operator= (GestureRotate && src) noexcept
| ~GestureRotate () noexcept override
GtkGestureRotate * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkGestureRotate * | gobj () const
| Provides access to the underlying C GObject. More...
GtkGestureRotate * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
double | get_angle_delta () const
| Gets the angle delta in radians. More...
Glib::SignalProxy< void(double, double)> | signal_angle_changed ()
Public Member Functions inherited from Gtk::Gesture
| Gesture (Gesture && src) noexcept
Gesture & | operator= (Gesture && src) noexcept
| ~Gesture () noexcept override
GtkGesture * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkGesture * | gobj () const
| Provides access to the underlying C GObject. More...
GtkGesture * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gdk::Device > | get_device ()
| Returns the logical `Gdk::Device` that is currently operating on gesture. More...
Glib::RefPtr< const Gdk::Device > | get_device () const
| Returns the logical `Gdk::Device` that is currently operating on gesture. More...
bool | set_state (EventSequenceState state)
| Sets the state of all sequences that gesture is currently interacting with. More...
EventSequenceState | get_sequence_state (Gdk::EventSequence * sequence) const
| Returns the sequence state, as seen by gesture. More...
bool | set_sequence_state (Gdk::EventSequence * sequence, EventSequenceState state)
| Sets the state of sequence in gesture. More...
std::vector< const Gdk::EventSequence * > | get_sequences () const
| Returns the list of Gdk::EventSequences currently being interpreted. More...
Gdk::EventSequence * | get_last_updated_sequence ()
| Returns the `Gdk::EventSequence` that was last updated on gesture. More...
const Gdk::EventSequence * | get_last_updated_sequence () const
| Returns the `Gdk::EventSequence` that was last updated on gesture. More...
bool | handles_sequence (Gdk::EventSequence * sequence) const
| Returns `true` if gesture is currently handling events corresponding to sequence. More...
Glib::RefPtr< Gdk::Event > | get_last_event (Gdk::EventSequence * sequence)
| Returns the last event that was processed for sequence. More...
Glib::RefPtr< const Gdk::Event > | get_last_event (Gdk::EventSequence * sequence) const
| Returns the last event that was processed for sequence. More...
bool | get_point (Gdk::EventSequence * sequence, double & x, double & y) const
| If sequence is currently being interpreted by gesture, returns `true` and fills in x and y with the last coordinates stored for that event sequence. More...
bool | get_bounding_box (Gdk::Rectangle & rect) const
| If there are touch sequences being currently handled by gesture, returns `true` and fills in rect with the bounding box containing all active touches. More...
bool | get_bounding_box_center (double & x, double & y) const
| If there are touch sequences being currently handled by gesture, returns `true` and fills in x and y with the center of the bounding box containing all active touches. More...
bool | is_active () const
| Returns `true` if the gesture is currently active. More...
bool | is_recognized () const
| Returns `true` if the gesture is currently recognized. More...
void | group (const Glib::RefPtr< Gesture > & group_gesture)
| Adds gesture to the same group than group_gesture. More...
void | ungroup ()
| Separates gesture into an isolated group. More...
std::vector< Glib::RefPtr< Gesture > > | get_group ()
| Returns all gestures in the group of gesture. More...
std::vector< Glib::RefPtr< const Gesture > > | get_group () const
| Returns all gestures in the group of gesture. More...
bool | is_grouped_with (const Glib::RefPtr< Gesture > & other) const
| Returns `true` if both gestures pertain to the same group. More...
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_begin ()
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_end ()
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_update ()
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_cancel ()
Glib::SignalProxy< void(Gdk::EventSequence *, EventSequenceState)> | signal_sequence_state_changed ()
Glib::PropertyProxy_ReadOnly< unsigned int > | property_n_points () const
| The number of touch points that trigger recognition on this gesture. More...
Public Member Functions inherited from Gtk::EventController
| EventController (EventController && src) noexcept
EventController & | operator= (EventController && src) noexcept
| ~EventController () noexcept override
GtkEventController * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkEventController * | gobj () const
| Provides access to the underlying C GObject. More...
GtkEventController * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Widget * | get_widget ()
| Returns the `Gtk::Widget` this controller relates to. More...
const Widget * | get_widget () const
| Returns the `Gtk::Widget` this controller relates to. More...
void | reset ()
| Resets the controller to a clean state. More...
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events. More...
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events. More...
PropagationLimit | get_propagation_limit () const
| Gets the propagation limit of the event controller. More...
void | set_propagation_limit (PropagationLimit limit)
| Sets the event propagation limit on the event controller. More...
Glib::ustring | get_name () const
| Gets the name of controller. More...
void | set_name (const Glib::ustring & name)
| Sets a name on the controller that can be used for debugging. More...
Glib::RefPtr< const Gdk::Event > | get_current_event () const
| Returns the event that is currently being handled by the controller. More...
guint32 | get_current_event_time () const
| Returns the timestamp of the event that is currently being handled by the controller. More...
Glib::RefPtr< Gdk::Device > | get_current_event_device ()
| Returns the device of the event that is currently being handled by the controller. More...
Glib::RefPtr< const Gdk::Device > | get_current_event_device () const
| Returns the event that is currently being handled by the controller. More...
Gdk::ModifierType | get_current_event_state () const
| Returns the modifier state of the event that is currently being handled by the controller. More...
Glib::PropertyProxy_ReadOnly< Widget * > | property_widget () const
| The widget receiving the `Gdk::Events` that the controller will handle. More...
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events. More...
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events. More...
Glib::PropertyProxy< PropagationLimit > | property_propagation_limit ()
| The limit for which events this controller will handle. More...
Glib::PropertyProxy_ReadOnly< PropagationLimit > | property_propagation_limit () const
| The limit for which events this controller will handle. More...
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name for this controller, typically used for debugging purposes. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name for this controller, typically used for debugging purposes. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< GestureRotate > | create ()
| Creates a Gesture that recognizes 2-touch rotation gestures. More...
Static Public Member Functions inherited from Gtk::Gesture
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| GestureRotate ()
| Constructs a Gesture that recognizes 2-touch rotation gestures. More...
Protected Member Functions inherited from Gtk::Gesture
| Gesture ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::GestureRotate > | wrap (GtkGestureRotate * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Gesture
Glib::RefPtr< Gtk::Gesture > | wrap (GtkGesture * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)

## Detailed Description

Rotate gesture.

This is a Gesture implementation able to recognize 2-finger rotations. Whenever the angle between both handled sequences changes, signal_angle_changed() is emitted.

Since gtkmm 3.14:

## Constructor & Destructor Documentation

## ◆ GestureRotate() [1/2]

Gtk::GestureRotate::GestureRotate | ( | GestureRotate && | src | ) |
| noexcept

## ◆ ~GestureRotate()

Gtk::GestureRotate::~GestureRotate | ( |  | ) |
| overridenoexcept

## ◆ GestureRotate() [2/2]

Gtk::GestureRotate::GestureRotate | ( |  | ) |
| protected

Constructs a Gesture that recognizes 2-touch rotation gestures.

## Member Function Documentation

## ◆ create()

static Glib::RefPtr< GestureRotate > Gtk::GestureRotate::create | ( |  | ) |
| static

Creates a Gesture that recognizes 2-touch rotation gestures.

Since gtkmm 3.14:

Returns
  A RefPtr to a new GestureRotate.

## ◆ get_angle_delta()

double Gtk::GestureRotate::get_angle_delta | ( |  | ) | const

Gets the angle delta in radians.

If gesture is active, this function returns the angle difference in radians since the gesture was first recognized. If gesture is not active, 0 is returned.

Returns
  The angle delta in radians.

## ◆ get_type()

static GType Gtk::GestureRotate::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkGestureRotate * Gtk::GestureRotate::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkGestureRotate * Gtk::GestureRotate::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkGestureRotate * Gtk::GestureRotate::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

GestureRotate & Gtk::GestureRotate::operator= | ( | GestureRotate && | src | ) |
| noexcept

## ◆ signal_angle_changed()

Glib::SignalProxy< void(double, double)> Gtk::GestureRotate::signal_angle_changed | ( |  | ) |

Slot Prototype:
  `void on_my_angle_changed(double angle, double angle_delta)`

Flags: Run First

Emitted when the angle between both tracked points changes.

Parameters

  angle | Current angle in radians.
  angle_delta | Difference with the starting angle, in radians.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::GestureRotate > wrap | ( | GtkGestureRotate * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.